/*
 * Copyright (c) 2005 Sun Microsystems, Inc.
 * All rights reserved. 
 */

package com.hisham.wsi;

import java.math.BigInteger;
import java.rmi.RemoteException;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;

import javax.xml.rpc.Stub;

import com.sun.wsi.scm.configuration.ConfigurationEndpointRole;
import com.sun.wsi.scm.configuration.ConfigurationFaultType;
import com.sun.wsi.scm.configuration.ConfigurationType;
import com.sun.wsi.scm.util.ConfigurationValidator;
import com.sun.wsi.scm.util.WSIConstants;
import com.sun.wsi.scm.warehouse.ItemShippingStatus;
import com.sun.wsi.scm.warehouse.WarehouseService_Impl;
import com.hisham.wsi.stubs.Item;
import com.hisham.wsi.stubs.ItemList;
import com.hisham.wsi.stubs.ItemShippingStatusList;
/*
import com.hisham.wsi.stubs.WarehouseService_Impl;
import com.hisham.wsi.stubs.WarehouseShipmentsPortType;
*/

/*
<?xml version="1.0" encoding="UTF-8"?>
<beans>
<jsr181:endpoint>
  <jsr181:pojo>
    <bean class="com.hisham.wsi.WarehouseServiceMixImpl">
      <property name="context" ref="context" />
    </bean>
  </jsr181:pojo>
</jsr181:endpoint>
</beans>
*/ 
public class WarehouseServiceMixImpl implements WSIConstants {

//	javax.jbi.component.ComponentContext context;

	public static WarehouseServiceMixImpl initialized = null;
//	LoggingFacilityLogPortType logStub = null;

	String className = getClass().getName();

//	Logger logger = null;

	//Localizer localizer = null;

//	PropertyResourceBundle resourceBundle = null;
/*
	public void setContext(javax.jbi.component.ComponentContext context) {
		this.context = context;
		this.init(context);
	}
*/
	private void init() {//javax.jbi.component.ComponentContext context) {
//		logger = Logger.getLogger(LOGGER, RESOURCE_BUNDLE);
//		logger.entering(className, INIT);
		/*
		localizer = new Localizer();

		// Prepare the stream for retailer resource bundle
		InputStream is = this.getClass().getResourceAsStream(RESOURCES);
		try {
			resourceBundle = new PropertyResourceBundle(is);
		} catch (IOException ex) {
			ex.printStackTrace();
		}*/
	}
	
	public synchronized void initConditionally() {
		if(initialized==null) {
			initialized = this;
			init();
		}
		
	}
	public ItemShippingStatusList shipGoods(ItemList itemList, String customer,com.hisham.sun.wsi.scm.configuration.ConfigurationType configHeader) throws 
			RemoteException {
		initConditionally();
		ConfigurationType configurationHeader = configHeader.toConfigurationType();
		Hashtable roles = null;
		try {
			roles = ConfigurationValidator.validateHeader(configurationHeader);
		} catch (ConfigurationFaultType e) {
			e.printStackTrace();
			throw new RemoteException(e.getMessage(),e);
		}
		
		// ** - Initialize the response
		// Used to correlate with the list of items that
		// could not be ordered by a particular warehouse
		Hashtable<BigInteger,Item> requestHash = new Hashtable<BigInteger,Item>();
		Hashtable<BigInteger,ItemShippingStatus> responseHash = new Hashtable<BigInteger,ItemShippingStatus>();
		Item[] partsOrderList = itemList.getItem();
		for (int i = 0; i < partsOrderList.length; i++) {
			// Initialize the requestHash with the original request
			requestHash.put(
				partsOrderList[i].getProductNumber(),
				partsOrderList[i]);

			// Initialize the response with productNumber
			ItemShippingStatus responseItem = new ItemShippingStatus();
			responseItem.setProductNumber(partsOrderList[i].getProductNumber());

			// Initialize the responseHash with the initialized response
			responseHash.put(
				partsOrderList[i].getProductNumber(),
				responseItem);
		}
		/***initWarehouses****************************************/
		WarehouseService_Impl warehouseService = new WarehouseService_Impl();

		// configure WarehouseA stub
		com.sun.wsi.scm.warehouse.WarehouseShipmentsPortType warehouseAStub = warehouseService
				.getWarehouseAPort();
		((Stub) warehouseAStub)._setProperty(
				Stub.ENDPOINT_ADDRESS_PROPERTY,
				roles.get(ConfigurationEndpointRole.WarehouseA));
		// configure WarehouseB stub
		com.sun.wsi.scm.warehouse.WarehouseShipmentsPortType warehouseBStub = warehouseService
				.getWarehouseBPort();
		((Stub) warehouseBStub)._setProperty(
				Stub.ENDPOINT_ADDRESS_PROPERTY,
				roles.get(ConfigurationEndpointRole.WarehouseB));
		// configure WarehouseC stub
		com.sun.wsi.scm.warehouse.WarehouseShipmentsPortType warehouseCStub = warehouseService
				.getWarehouseCPort();
		((Stub) warehouseCStub)._setProperty(
				Stub.ENDPOINT_ADDRESS_PROPERTY,
				roles.get(ConfigurationEndpointRole.WarehouseC));
		/*End initWarehouses********************************************/
		// Process order with WarehouseA
		com.sun.wsi.scm.warehouse.ItemList itemListW = itemList.toItemList(); 
		com.sun.wsi.scm.warehouse.ItemShippingStatusList itemShippingStatusList;
		try {
			itemShippingStatusList = warehouseAStub
					.shipGoods(itemListW, customer,configurationHeader);
		com.sun.wsi.scm.warehouse.ItemList unshippedItemList = getUnshippedItems(itemShippingStatusList,
				itemListW,requestHash,responseHash);
			
		// If WarehouseA is not able to ship all the goods,
		// then WarehouseB is invoked
		if (unshippedItemList.getItem().length > 0) {
			itemShippingStatusList = warehouseBStub.shipGoods(
					unshippedItemList, customer,configurationHeader);
			unshippedItemList = getUnshippedItems(itemShippingStatusList,
					unshippedItemList,requestHash,responseHash);

			// If WarehouseB is not able to ship the remaining goods,
			// then WarehouseC is invoked
			if (unshippedItemList.getItem().length > 0) {
				itemShippingStatusList = warehouseCStub.shipGoods(
						unshippedItemList, customer,configurationHeader);
				unshippedItemList = getUnshippedItems(itemShippingStatusList,
						unshippedItemList,requestHash,responseHash);

			}
			ItemShippingStatus[] itemShippingStatus = new ItemShippingStatus[responseHash.size()];
			Enumeration<ItemShippingStatus> elements = responseHash.elements();
			int i=0;
			while(elements.hasMoreElements()) {
				itemShippingStatus[i++] = elements.nextElement();
			}
			return new ItemShippingStatusList(itemShippingStatus);
		}
		} catch (ConfigurationFaultType e) {
			throw new RemoteException(e.getMessage(),e);
		}
		catch(Throwable t) {
			t.printStackTrace();
			throw new RemoteException(t.getMessage(),t);
		}
		return null;
	}

	/***********************************************************/

	private com.sun.wsi.scm.warehouse.ItemList getUnshippedItems(
			com.sun.wsi.scm.warehouse.ItemShippingStatusList itemShippingStatusList,
			com.sun.wsi.scm.warehouse.ItemList requestItemList,
			Hashtable<BigInteger,Item> requestHash,
			Hashtable<BigInteger,ItemShippingStatus> responseHash) {
		ItemShippingStatus[] itemShippingStatusArray = itemShippingStatusList
				.getItemStatus();

		ArrayList<BigInteger> unshippedItems = new ArrayList<BigInteger>();
		// Sets a valid value in the responseHash for all the items 
		// shipped by the warehouse defined by "role" parameter
		for (int i = 0; i < itemShippingStatusArray.length; i++) {
			BigInteger productNumber =
				itemShippingStatusArray[i].getProductNumber();
			if (itemShippingStatusArray[i].isStatus()) {
				Item requestItem =
					requestHash.get(productNumber);
				ItemShippingStatus responseItem =
					 responseHash.get(productNumber);
				responseItem.setStatus(itemShippingStatusArray[i].isStatus());
				/*
				String desc =
					localizer.localize(
						resourceBundle.getString("retailer.processOrder.inStock"),
						role);
				responseItem.setComment(desc);
				*/
				responseHash.put(productNumber, responseItem);
			} else {
				unshippedItems.add(itemShippingStatusArray[i]
						.getProductNumber());
			}
		}

		// Collect products not shipped by a warehouse. Quanity is
		// obtained from the original request as ItemShippingStatus
		// (response from Warehouse) does not contain quantity
		com.sun.wsi.scm.warehouse.Item[] requestItemArray = requestItemList.getItem();
		Hashtable<BigInteger, Integer> quantityHash = new Hashtable<BigInteger, Integer>();
		for (int i = 0; i < requestItemArray.length; i++)
			quantityHash.put(requestItemArray[i].getProductNumber(),
					new Integer(requestItemArray[i].getQuantity()));

		com.sun.wsi.scm.warehouse.Item[] unshippedItemArray = new com.sun.wsi.scm.warehouse.Item[unshippedItems.size()];
		for (int i = 0; i < unshippedItems.size(); i++) {
			BigInteger productNumber = (BigInteger) unshippedItems.get(i);
			unshippedItemArray[i] = new com.sun.wsi.scm.warehouse.Item();
			unshippedItemArray[i].setProductNumber(productNumber);

			// quantity is ignored
			unshippedItemArray[i].setQuantity((quantityHash.get(productNumber))
					.intValue());
		}

		com.sun.wsi.scm.warehouse.ItemList unshippedItemList = new com.sun.wsi.scm.warehouse.ItemList();
		unshippedItemList.setItem(unshippedItemArray);
		return unshippedItemList;
	}
}
